#! /bin/sh                                                      

n=1

RES=`zenity --title="Image Width" --width=150 --height=100 --entry --text="Képátméretező -- Határozd meg a \nképszélességet pixelben (pl. 600)"`
   if [ $? == 1 ]; then
      exit
   fi

EXT=$(zenity --list --column="Válassz egyet" --title="Képkonvertálás" --width=250 --height=250 --text="Válaszd ki a képformátumot\namire konvertál:" jpg png webp avif tiff bmp gif)
   if [ $? == 1 ]; then
      exit
   fi
declare -l EXT
EXT=$EXT

QUAL=`zenity --title="Képkonvertálás" --width=250 --height=250 --entry --text="Add meg a minőségi mutatót:\n\n100 = Legjobb\n75 = 75%-os minőség\n50 = 50%-os V\n\nBármilyen szám\n1 és 100 között."`
   if [ $? == 1 ]; then
      exit
   fi
   if [[ ( $(($QUAL)) -lt 1 ) || ( $(($QUAL)) -gt 100 ) ]]; then
      zenity --title="Képkonvertálás" --width=200 --height 100 --error --text="Kilépés.\n\nA bevitt érték\nnem érvényes."
      exit
   fi

DIR=`zenity --title="Célkönyvtár" --entry --text="Add meg a célkönyvtárat.\n\n Írj ./-t az aktuális és \nírj ../ a szülő könyvtárhoz.\n"`
   if [ $? == 1 ]; then
      exit
   fi
   if [ ! -d $DIR ]; then
      mkdir $DIR
   fi

if [ $EXT == "png" ];
   then
      BACKGROUND="none"
      QUALITY=$(($QUAL / 10))
   else
      BACKGROUND="white"
      QUALITY="$QUAL"
fi

REZ=$((RES-2))

for file in $@; do
    if [ ! -e $file ]; then
        continue
    fi

    name=$( echo $file | cut -f1 -d.)
    convert $file -units pixelsperinch -resample 72x72 -resize $REZ -quality $QUALITY -fuzz 20% -background $BACKGROUND -bordercolor black -border 1x1 $DIR/${name}_$RES-$QUALITY.$EXT
    echo $(($n * 100 / $#))
    echo "# Processing file: $file"
    let "n = n+1"

done | (zenity  --progress --title "Resizing..." --percentage=0 --auto-close --auto-kill)

exit 0
