#! /bin/sh                                                      

n=1

FILES=$(zenity --file-selection --multiple --separator=" " --filename "${HOME}/" --file-filter='Graphic Files | *.png *.PNG *.jpg *.JPG *.webp *.WEBP *.avif *.AVIF *.gif *.GIF *.bmp *.BMP *.tiff *.TIFF' --title="Válaszd ki az átméretezendő képfájlt!")
   if [ $? == 1 ]; then
      exit
   fi
read -r -a "FILES" <<< $FILES
count=${#FILES[@]}

RES=`zenity --title="Képszélesség" --width=150 --height=100 --entry --text="Képátméretező -- Kérem írd be a \nképszélességet pixelben (pl. 600)"`
   if [ $? == 1 ]; then
      exit
   fi

EXT=$(zenity --list --column="Válasz egyet" --title="Képkonvertáló" --width=250 --height=250 --text="Válaszd ki a képformátumot\namire konvertál:" jpg png webp avif tiff bmp gif)
   if [ $? == 1 ]; then
      exit
   fi
declare -l EXT
EXT=$EXT

QUAL=`zenity --title="Képkonvertáló" --width=250 --height=250 --entry --text="Határozd meg a minőségi szintet:\n\n100 = Legjobb\n75 = 75%-os minőség\n50 = 50%-os minőség\n\nBármilyen szám\n1 és 100 között jó."`
   if [ $? == 1 ]; then
      exit
   fi
   if [[ ( $(($QUAL)) -lt 1 ) || ( $(($QUAL)) -gt 100 ) ]]; then
      zenity --title="Képkonvertáló" --width=200 --height 100 --error --text="Kilép.\n\nA beírt szám\nnincs a tartományban."
      exit
   fi

DIR=`zenity --title="Célkönyvtár" --width=350 --entry --text="Add meg, hogy az átméretezett képet \nhova mentse.\n\nHagyd üresen, ha a fájlt ugyanabba \na könyvtárba mentenéd amiben az eredeti van.\n"`
   if [ $? == 1 ]; then
      exit
   fi
CURR_PATH=$(dirname "${FILES[0]}")
NEW_DIR=$CURR_PATH"/"$DIR
   if [ ! -d $NEW_DIR ]; then
      mkdir $NEW_DIR
   fi

if [ $EXT == "png" ];
   then
      BACKGROUND="none"
      QUALITY=$(($QUAL / 10))
   else
      BACKGROUND="white"
      QUALITY="$QUAL"
fi

REZ=$((RES-2))

for file in "${FILES[@]}"; do
    if [ ! -e $file ]; then
        continue
    fi
    
    nopath=$(basename "$file")
    name=$( echo $nopath | cut -f1 -d.)
    convert $file -units pixelsperinch -resample 72x72 -resize $REZ -quality $QUALITY -fuzz 20% -background $BACKGROUND -bordercolor black -border 1x1 $NEW_DIR/${name}_$RES-$QUALITY.$EXT
    echo $(($n * 100 / $count))
    echo "# Processing file: $file"
    let "n = n+1"

done | (zenity  --progress --title "Resizing..." --percentage=0 --auto-close --auto-kill)

exit 0
